
import java.awt.*;
import java.awt.event.*;
import java.util.List;
import java.util.*;

public class GreedSnake extends Frame{

	private static final int GAME_WIDTH = 800;
	private static final int GAME_HEIGHT = 600;
	
	public static Random rd = new Random();
	int fx = rd.nextInt(39)+1;
	int fy = rd.nextInt(29)+1;
	
	Image offScreen = null;
	
	private boolean isRun = true;
	Snake s = new Snake(new Point(200,200),5,this);
	List<Food> foods = new ArrayList<Food>();

	Dialog gameOver;

	public void launchFrame() {
		setTitle("Snake");
		setBounds(300,300,GAME_WIDTH,GAME_HEIGHT);
		setVisible(true);
		setResizable(false); 
		new Thread(new RPaint()).start();
		addWindowListener(new WindowMonitor());
		addKeyListener(new DirectionMonitor());

		gameOver = new Dialog(this,true);
		gameOver.setBounds(600,500,200,100);
		gameOver.setResizable(false);
		Button b1 = new Button("Restart");
		Button b2 = new Button("Quit");
		Label l = new Label("        GAME OVER !         ",Label.CENTER);
		gameOver.add(l);
		gameOver.add(b1);
		gameOver.add(b2);
		gameOver.setLayout(new FlowLayout());
		b2.addActionListener(new Listener());
	}

	private class WindowMonitor extends WindowAdapter{
		public void windowClosing(WindowEvent e){
			System.exit(0);
		}
	}

	private class DirectionMonitor extends KeyAdapter{
		public void keyPressed(KeyEvent e){
			s.keyPressed(e);
		}
	}

	public void paint(Graphics g){
		if(!s.isAlive()){
			gameOver.setVisible(true);
			isRun = false;
		}
		if(foods.size()==0){
			foods.add(new Food(20*fx,20*fy));
			fx = rd.nextInt(39)+1;
			fy = rd.nextInt(29)+1;
		}

		for(int i=0;i<foods.size();i++){
			foods.get(i).draw(g);
		}
		s.paint(g);
	}
	
	public void update(Graphics g){
		if(offScreen == null){
				offScreen = this.createImage(GAME_WIDTH,GAME_HEIGHT);
			}
			Graphics gDrawner = offScreen.getGraphics();
			Color c = gDrawner.getColor();
			gDrawner.setColor(Color.WHITE);
			gDrawner.fillRect(0,0,GAME_WIDTH,GAME_HEIGHT);
			gDrawner.setColor(c);
			paint(gDrawner);
			g.drawImage(offScreen,0,0,null);
	}

	private class RPaint implements Runnable{
		public void run(){
			while(isRun){
				repaint();
				try{
					Thread.sleep(20);
				}catch(InterruptedException e){
					e.printStackTrace();
				}
			}
		}
	}
	
	public class Listener implements ActionListener{
		public void actionPerformed(ActionEvent e){
			if(e.getActionCommand()=="Quit"){
				System.exit(0);
			}else if(e.getActionCommand()=="Restart"){
				//s = new Snake(new Point(200,200),5,this);
				//s.Live(true);
				//gameOver.setVisible(false);
			}
		}
	}

	public static void main(String[] args){
		new GreedSnake().launchFrame();
	}
}